''' <summary>
''' Classe de base pour les dictionnaires
''' </summary>
''' <remarks></remarks>
Friend MustInherit Class ClsBaseDict(Of TKey)
    Implements IDict
    ''' <summary>
    ''' Dictionnaire des cls
    ''' </summary>
    ''' <remarks></remarks>
    Protected mDict As New SortedDictionary(Of TKey, IDict)
    ''' <summary>
    ''' Type de controle reastant  faire
    ''' </summary>
    ''' <remarks></remarks>
    Protected mTypeCtrl As EFileCtrl = 0
    ''' <summary>
    ''' Valeur temporaire
    ''' </summary>
    ''' <remarks></remarks>
    Private mTmpValue As String = ""

    ''' <summary>
    ''' Constructeur de la classe
    ''' </summary>
    ''' <param name="pTypeCtrl">Type de controle restant  faire</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal pTypeCtrl As EFileCtrl)
        mTypeCtrl = pTypeCtrl
    End Sub
    ''' <summary>
    ''' Ajoute un fichier  la liste
    ''' </summary>
    ''' <param name="pObj">Fichier  ajouter</param>
    ''' <remarks></remarks>
    Public Overridable Sub Add(ByVal pObj As IO.FileInfo) Implements IDict.Add
        If mDict.Count = 0 And mTmpValue = "" Then
            mTmpValue = pObj.FullName
            Exit Sub
        ElseIf mDict.Count = 0 AndAlso mTmpValue.Length <> 0 And pObj.FullName <> mTmpValue Then
            Add(New IO.FileInfo(mTmpValue))
            mTmpValue = ""
        End If

        Dim lDict As IDict = Nothing
        Dim lKey As TKey = CalcKey(pObj)

        If mDict.TryGetValue(lKey, lDict) Then
            lDict.Add(pObj)
        Else
            If (mTypeCtrl And EFileCtrl.Extension) <> 0 Then
                lDict = New ClsDictExtension(mTypeCtrl)
            ElseIf (mTypeCtrl And EFileCtrl.FileName) <> 0 Then
                lDict = New ClsDictFileName(mTypeCtrl)
            ElseIf (mTypeCtrl And EFileCtrl.Taille) <> 0 Then
                lDict = New ClsDictSize(mTypeCtrl)
            ElseIf (mTypeCtrl And EFileCtrl.MD5) <> 0 Then
                lDict = New ClsDictMD5(mTypeCtrl)
            Else
                lDict = New ClsDictDbl
            End If
            lDict.Add(pObj)
            mDict.Add(lKey, lDict)
        End If
    End Sub
    ''' <summary>
    ''' Calcul de la cl pour le dictionnaire
    ''' </summary>
    ''' <param name="pFile">Fichier source</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Protected MustOverride Function CalcKey(ByVal pFile As IO.FileInfo) As TKey
    ''' <summary>
    ''' Retourne le nombre de doublon  ce niveau de la hirarchie
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overridable ReadOnly Property NbDoublons() As Integer Implements IDict.NbDoublons
        Get
            Dim lInt As Integer = 0
            For Each lObj As IDict In mDict.Values
                lInt += lObj.NbDoublons
            Next
            Return lInt
        End Get
    End Property
    ''' <summary>
    ''' Retourne la liste des noeuds des doublons
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overridable Function GetDoublons() As List(Of TreeNode) Implements IDict.GetDoublons
        Dim lNode As New List(Of TreeNode)
        For Each lObj As IDict In mDict.Values
            lNode.AddRange(lObj.GetDoublons)
        Next
        Return lNode
    End Function
End Class
