Public Class ClsDictDbl
    Implements IDict
    ''' <summary>
    ''' Liste des nom de fichiers
    ''' </summary>
    ''' <remarks></remarks>
    Private mList As New List(Of String)

    ''' <summary>
    ''' Constructeur de la classe
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        'e
    End Sub
    ''' <summary>
    ''' Ajoute un fichier  la liste
    ''' </summary>
    ''' <param name="pObj">Fichier  ajouter</param>
    ''' <remarks></remarks>
    Public Sub Add(ByVal pObj As System.IO.FileInfo) Implements IDict.Add
#If DEBUG Then
        Debug.Print("ClsDictDbl : ""{0}""", New Object() {pObj.FullName})
#End If
        For Each lStr As String In mList
            If pObj.FullName = lStr Then Exit Sub
        Next
        mList.Add(pObj.FullName)
    End Sub
    ''' <summary>
    ''' Retourne un noeud pour affichage si ncssaire
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetDoublons() As System.Collections.Generic.List(Of System.Windows.Forms.TreeNode) Implements IDict.GetDoublons
        Dim lList As New List(Of TreeNode)
        Dim lAttr As IO.FileAttributes
        If mList.Count > 1 Then
            For i As Integer = 1 To mList.Count - 1
                lList.Add(New TreeNode(IO.Path.GetFileName(mList(i)), 1, 1))
                With lList(lList.Count - 1)
                    .Tag = mList(i)
                    lAttr = IO.File.GetAttributes(mList(i))
                    If (lAttr And IO.FileAttributes.Hidden) <> 0 Then
                        .SelectedImageIndex += 2
                        .StateImageIndex += 2
                    End If
                    If (lAttr And IO.FileAttributes.System) <> 0 Then
                        .SelectedImageIndex += 4
                        .StateImageIndex += 4
                    End If
                    If (lAttr And IO.FileAttributes.ReadOnly) <> 0 Then
                        .SelectedImageIndex += 8
                        .StateImageIndex += 8
                    End If
                End With
            Next
            Dim lNode As New TreeNode(IO.Path.GetFileName(mList(0)), 1, 1, lList.ToArray)
            lNode.Tag = mList(0)

            lAttr = IO.File.GetAttributes(mList(0))
            If (lAttr And IO.FileAttributes.Hidden) <> 0 Then
                lNode.SelectedImageIndex += 2
                lNode.StateImageIndex += 2
            End If
            If (lAttr And IO.FileAttributes.System) <> 0 Then
                lNode.SelectedImageIndex += 4
                lNode.StateImageIndex += 4
            End If
            If (lAttr And IO.FileAttributes.ReadOnly) <> 0 Then
                lNode.SelectedImageIndex += 8
                lNode.StateImageIndex += 8
            End If

            lList = New List(Of TreeNode)
            lList.Add(lNode)
        End If
        Return lList
    End Function
    ''' <summary>
    ''' Retourne le nombre de doublons (0/1)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property NbDoublons() As Integer Implements IDict.NbDoublons
        Get
            If mList.Count > 1 Then
                Return 1
            Else
                Return 0
            End If
        End Get
    End Property
End Class
