Friend Class ClsDictMD5
    Inherits ClsBaseDict(Of String)

    ''' <summary>
    ''' Constructeur de la classe
    ''' </summary>
    ''' <param name="pCtrl">Type de controles  effectuer</param>
    ''' <remarks></remarks>
    Friend Sub New(ByVal pCtrl As EFileCtrl)
        MyBase.New(pCtrl And Not (EFileCtrl.MD5))
    End Sub
    ''' <summary>
    ''' Retourne la cl
    ''' </summary>
    ''' <param name="pFile">Fichier</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Protected Overrides Function CalcKey(ByVal pFile As System.IO.FileInfo) As String
        Dim lSize As Long
        If My.Settings.CtrlMd5Size = "*" Then
            lSize = 0
        ElseIf My.Settings.CtrlMd5Size.Substring(0, 1) = "k" Then
            If Not Long.TryParse(My.Settings.CtrlMd5Size.Substring(1), lSize) Then
                lSize = 0
            Else
                lSize *= 1024
            End If
        ElseIf My.Settings.CtrlMd5Size.Substring(0, 1) = "%" Then
            Dim lDecimal As Decimal
            If (pFile.Length >= Integer.MaxValue) OrElse Not Decimal.TryParse(My.Settings.CtrlMd5Size.Substring(1), lDecimal) Then
                lSize = 0
            Else
                lSize = CLng(lDecimal * pFile.Length)
            End If
        End If
        Return Convert.ToBase64String(GetHashMD5(pFile.FullName, lSize))
    End Function
End Class
