Module MdlFriend

    ''' <summary>
    ''' Enumration des controles sur les fichiers
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum EFileCtrl As Integer
        ''' <summary>
        ''' Controle les extensions
        ''' </summary>
        ''' <remarks></remarks>
        Extension = 1
        ''' <summary>
        ''' Controle le nom des fichiers (sans l'extension)
        ''' </summary>
        ''' <remarks></remarks>
        FileName = 2
        ''' <summary>
        ''' Controle la taille des fichiers
        ''' </summary>
        ''' <remarks></remarks>
        Taille = 4
        ''' <summary>
        ''' Controle le Hash MD5 des fichiers
        ''' </summary>
        ''' <remarks></remarks>
        MD5 = 8
    End Enum

    ''' <summary>
    ''' Retourne le Hash MD5 du fichier
    ''' </summary>
    ''' <param name="pFileName">Nom du fichier  traiter</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetHashMD5(ByVal pFileName As String, Optional ByVal pLength As Long = 0) As Byte()
        Dim ltTab As Byte()
        Try
            Dim f As New IO.FileStream(pFileName, IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.Read, 8192)
            Dim MD5 As New System.Security.Cryptography.MD5CryptoServiceProvider

            If pLength > 0 And pLength <= Integer.MaxValue And (New IO.FileInfo(pFileName)).Length > pLength Then
                ReDim ltTab(CInt(pLength - 1))
                f.Read(ltTab, 0, ltTab.Length)
                MD5.ComputeHash(ltTab)
            Else
                MD5.ComputeHash(f)
            End If
            f.Close()
            ltTab = MD5.Hash
            f = Nothing
            MD5 = Nothing
        Catch ex As Exception
            ReDim ltTab(-1)
        End Try
        Return ltTab
    End Function
End Module
